class W3Effect_AlbedoDominance extends CBaseGameplayEffect
{
	default effectType = EET_AlbedoDominance;	
	default isPositive = true;
	default isNeutral = false;
	default isNegative = false;
	
	private var update_interval : float;
	private var current_toxicity : float;
	private var saved_toxicity_value : float;
	private var witcher	: W3PlayerWitcher;
	
	event OnEffectAdded(optional customParams : W3BuffCustomParams)
	{	witcher = GetWitcherPlayer();
		saved_toxicity_value = witcher.GetStat(BCS_Toxicity, false);	
		super.OnEffectAdded(customParams);
	}
	
	event OnUpdate(time : float)
	{	update_interval += time;		
		if (update_interval > 1.0f)
		{	update_interval = 0;
			current_toxicity = witcher.GetStat(BCS_Toxicity, false);
			if (saved_toxicity_value < current_toxicity)
			{	effectManager.CacheStatUpdate(BCS_Toxicity, ((current_toxicity - saved_toxicity_value) * -0.2f) );
				saved_toxicity_value = current_toxicity;				
			}				
		}
		super.OnUpdate(time);
	}
	
}