/*Primer Configuration File
-------------------------------------------------------;*/


abstract class AlchemyExtenderConfig
{		
	public var fire_source_type : int;	
	public var allow_campfire : bool; 
	public var allow_campfire_interior : bool;
	public var campfire_kindling_amount : int;
	public var max_potion_count :int;
	public var max_bomb_count :int;
	public var max_oil_count :int;	
	public var global_potion_duration : float;
	public var mutagen_potion_duration : float;
	public var global_mininum_potion_duration : float;
	public var mutagen_mininum_potion_duration : float;	
	public var potion_duration_multiplier : float;
	public var mutagen_duration_multiplier : float;
	public var standard_degeneration_rate : float;
	public var accelerated_degeneration_rate : float;
	public var accelerated_degeneration_threshold : float;
	public var deccelerated_combat_degeneration : bool;
	public var combat_degeneration_rate : float;
	public var residual_degeneration_rate : float;
	public var toxicity_update_interval : float;	
	public var cooked_quantity : int;
	public var time_based_alchemy : bool;
	public var alchemy_time_cost : float;
	public var distillation_time : float;
	public var mod_primary_substances : bool;
	public var mod_mutagens : bool;
	public var bottle_recycling : bool;	
	public var allow_realism_animations : bool;
	public var no_combat_animations : bool;
	public var combat_eat_animation : bool;
	public var allow_loot_animation : bool;
	public var is_using_menu : bool; //If you are going to use this file instead of the in-game menu to change the mod settings, you must set this to false. See below.
	
	
	
	

	

	
	
	
	//protected function loadSettings ()
	//{
	
		/*FIRE SETTINGS
		**************************;*/
		
		/*This setting controls whether or not you need to be near a fire source to perform alchemy.
		A value of 0 disables fire checks, you can perform alchemy everywhere. 
		A value of 1 means you can perform alchemy only near campfires.
		If set to 2 you can perform alchemy near campfires and big fire sources (bonfires, cooking places, etc)*/
		default fire_source_type = 2;	
		
		//Enables or disables the construction of campfires when performing alchemy. If enabled Geralt will make a campfire if all the right conditions are met.
		//That is, there is no other campfire in range, lit or otherwise, and you have the enough kindling to start the fire.
		default allow_campfire = true;	
		
		//This setting controls whether or not campfires can be built in interior locations.
		default allow_campfire_interior = true;	
		
		/*This setting determines the amount of timber or hardened timber needed to make a campfire. You can have a combination of both to meet this value and the right amount
		of each will be correctly deducted from your inventory.*/
		default campfire_kindling_amount = 4;
		
		
		
		
		/*POTIONS AND OILS
		**************************;*/	
		
		
		//Maximum quantity for potions, oils and bombs. Set to any positive integer value you want up to 2^32. A value of 0 means unlimited items.
		default max_potion_count = 0;
		default max_bomb_count = 0;
		default max_oil_count = 0;
		
		/*This setting controls the base duration of non mutagenic potions. The value is given in seconds and can be set to any positive rational number.
		The value specified here will be further extended by your in-game alchemy skill modifiers. Set to 0 to use the default values specified by the game's xml files.*/
		default global_potion_duration = 0;
		
		/* While the setting above will overwrite the duration of potions, this setting will add to it, as long as the initial duration is lower than the value specified here.
		For instance a potion with a 30 sec duration will end up lasting 270 sec, 30 + the default 240 specified below; a potion with an initial duration 0f 241 sec will be untouched.
		This setting will have no effect if global_potion_duration is set to anything other than 0.
		The final duration will be further modified by other in-game alchemy skill related modifiers. Set to 0 to disable. */
		default global_mininum_potion_duration = 240.f;
		
		//Same as global_potion_duration but for mutagen potions. Set to 0 to disable and leave the default game value unchanged.
		default mutagen_potion_duration = 0;
		
		/* Same as global_mininum_potion_duration but for mutagen potions Set to 0 to disable. */
		default mutagen_mininum_potion_duration = 0;
		
		/* This setting multiplies the potion duration after it's modified by global_mininum_potion_duration or its mutagen sibling, to generate a final duration. 
		The value will still be affected by in-game alchemy skill modifiers. It has no effect if the initial potion duration is greater than global_mininum_potion_duration.
		Set to 0 to disable */	
		default potion_duration_multiplier = 0;
		
		/*Same as potion_duration_multiplier but for mutagenic potions*/
		default mutagen_duration_multiplier = 0;
		
		
		
		
		/*TOXICITY SETTINGS
		**************************;*/	
		
		
		/*Standard rate at which Geralt clears toxicity from his system when no other modifiers have precedence. With a value of 1.0, toxicity will last exactly as long as the potion
		effect is active. It will wane proportionally with the potion's duration*/
		default standard_degeneration_rate = 0.25f;
		
		/*Toxicity degeneration value that takes precedence over standard_degeneration_rate when the potion's time left is lower than the threshold specified below. */	
		default accelerated_degeneration_rate = 1.75f;

		/*This value controls when accelerated_degeneration_rate becomes active. It represents a percentage of the total potion duration.
		When the potion's time left is lower than this, accelerated_degeneration_rate will take precedence and standard_degeneration_rate will have no effect. 
		Set to 0 to disable Accelerated Degeneration*/	
		default accelerated_degeneration_threshold = 0.25f;
		
		// This setting controls whether or not toxicity degeneration changes while in combat.
		default deccelerated_combat_degeneration = false;
		
		// Rate at which toxicity degenerates while in combat. Has no effect if the above setting is disabled.
		default combat_degeneration_rate = 0.1f;	

		/*This setting controls the rate at which toxicity is removed -if there is any left- after all potions have lost their effect.
		It represents a percentage of total toxicity */
		default residual_degeneration_rate = 0.1;
		
		//Interval at which toxicity effects are evaluated. Included here for testing purposes; I recommend not to touch it as it will throw off all other settings.
		default toxicity_update_interval = 1.0f; // Do NOT touch
		
		
		
		
		/*TIME SETTINGS
		**************************;*/
		
		
		// This setting determines whether or not the preparation of alchemical concoctions requires time. If this is NOT active, the settings below will have no effect.
		default time_based_alchemy = true;
		
		// Cost in game minutes per per alchemy concoction prepared.
		default alchemy_time_cost = 10.0f;
		
		// Cost in game minutes of distilling ingredients to obtain primary substances.
		default distillation_time = 20.0f;	
		
		
		
		
		/*MISCELLANEOUS SETTINGS
		**************************;*/
		
		
		// Amount of items obtained when crafting alchemy recipes.
		default cooked_quantity = 1;
		
		// This setting controls if primary substances, Aether, Rebis, Vermilion, etc, get modified recipes. I strongly recommend to leave this setting on.
		default mod_primary_substances = true;
		
		// Determines whether or not monster mutagens can be used to create lesser mutagens of the same color.
		default mod_mutagens = true;
		
		// If this setting is active, every time you use an alcohol bottle in alchemy you save the empty bottle instead of discarding it.
		default bottle_recycling = true;
		
		// When this setting is active Geralt will perform eat, drink apply oil and loot animations.
		default allow_realism_animations = true;
		
		// If set to true, disables all realism animations during combat, allowing them otherwise.
		default no_combat_animations = false;
		
		// Allows the eating animation to be performed during combat. Eating during combat is prohibited in vanilla but you can still do it if the edible item is in a quick slot.
		default combat_eat_animation = true;	
		
		// Controls whether or not the looting animation is allowed.
		default allow_loot_animation = true;		
		
		// If you are not planning on using the in-game menu you must set this to false or the settings here will have no effect and the mod will misbehave.
		default is_using_menu = true;
		
	//}
	/*****************************************************************************/
	// Do not touch anything below.
	public function updateModSettings ()
	{	fire_source_type = StringToInt(theGame.GetInGameConfigWrapper().GetVarValue('fire_sources', 'fire_source_type') );
		allow_campfire = theGame.GetInGameConfigWrapper().GetVarValue('fire_sources', 'allow_campfire');
		allow_campfire_interior = theGame.GetInGameConfigWrapper().GetVarValue('fire_sources', 'allow_campfire_interior');
		campfire_kindling_amount = StringToInt(theGame.GetInGameConfigWrapper().GetVarValue('fire_sources', 'campfire_kindling_amount') );
		
		max_potion_count = StringToInt(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'max_potion_count') );
		max_oil_count = StringToInt(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'max_oil_count') );
		max_bomb_count = StringToInt(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'max_bomb_count') );
		global_potion_duration = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'global_potion_duration') );
		global_mininum_potion_duration = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'global_mininum_potion_duration') );
		mutagen_potion_duration = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'mutagen_potion_duration') );
		mutagen_mininum_potion_duration = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'mutagen_mininum_potion_duration') );
		potion_duration_multiplier = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'potion_duration_multiplier') );
		mutagen_duration_multiplier = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('potions_and_oils', 'mutagen_duration_multiplier') );
	
		standard_degeneration_rate = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('toxicity_settings', 'standard_degeneration_rate') );
		accelerated_degeneration_rate = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('toxicity_settings', 'accelerated_degeneration_rate') );
		accelerated_degeneration_threshold = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('toxicity_settings', 'accelerated_degeneration_threshold') );
		deccelerated_combat_degeneration = theGame.GetInGameConfigWrapper().GetVarValue('toxicity_settings', 'deccelerated_combat_degeneration');
		combat_degeneration_rate = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('toxicity_settings', 'combat_degeneration_rate') );
		residual_degeneration_rate = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('toxicity_settings', 'residual_degeneration_rate') );
		
		
		time_based_alchemy = theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'time_based_alchemy');	
		alchemy_time_cost = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'alchemy_time_cost') );
		distillation_time = StringToFloat(theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'distillation_time') );
		cooked_quantity = StringToInt(theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'cooked_quantity') );
		mod_primary_substances = theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'mod_primary_substances');
		mod_mutagens = theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'mod_mutagens');
		bottle_recycling = theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'bottle_recycling');
		allow_realism_animations = theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'allow_realism_animations');
		no_combat_animations = theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'no_combat_animations');
		combat_eat_animation = theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'combat_eat_animation');
		allow_loot_animation = theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'allow_loot_animation');
		
		if (theGame.GetInGameConfigWrapper().GetVarValue('miscellaneous_settings', 'uninstall_mod') )
		{	theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'primer_uninstall', "false");
			((W3PlayerAbilityManager)(GetWitcherPlayer().abilityManager)).restoreAllSkills();	
			GetWitcherPlayer().DisplayHudMessage(GetLocStringByKeyExt("primer_uninstalled") );								
		}				
	}
	
	protected function setMenuSettings ()
	{	theGame.GetInGameConfigWrapper().SetVarValue('fire_sources', 'fire_source_type', "2");
		theGame.GetInGameConfigWrapper().SetVarValue('fire_sources', 'allow_campfire', "true");
		theGame.GetInGameConfigWrapper().SetVarValue('fire_sources', 'allow_campfire_interior', "true");
		theGame.GetInGameConfigWrapper().SetVarValue('fire_sources', 'campfire_kindling_amount', "4");
		
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'max_potion_count', "0");
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'max_oil_count', "0");
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'max_bomb_count', "0");
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'global_potion_duration', "0");
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'global_mininum_potion_duration', "240");
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'mutagen_potion_duration', "0");
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'mutagen_mininum_potion_duration', "0");
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'potion_duration_multiplier', "0");
		theGame.GetInGameConfigWrapper().SetVarValue('potions_and_oils', 'mutagen_duration_multiplier', "0");
	
		theGame.GetInGameConfigWrapper().SetVarValue('toxicity_settings', 'standard_degeneration_rate', "0.25");
		theGame.GetInGameConfigWrapper().SetVarValue('toxicity_settings', 'accelerated_degeneration_rate', "1.75");
		theGame.GetInGameConfigWrapper().SetVarValue('toxicity_settings', 'accelerated_degeneration_threshold', "0.25");
		theGame.GetInGameConfigWrapper().SetVarValue('toxicity_settings', 'deccelerated_combat_degeneration', "false");
		theGame.GetInGameConfigWrapper().SetVarValue('toxicity_settings', 'combat_degeneration_rate', "0");
		theGame.GetInGameConfigWrapper().SetVarValue('toxicity_settings', 'residual_degeneration_rate', "0.1");
		
		
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'time_based_alchemy', "true");	
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'alchemy_time_cost', "10");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'distillation_time', "20");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'cooked_quantity', "1");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'mod_primary_substances', "true");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'mod_mutagens', "true");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'bottle_recycling', "true");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'allow_realism_animations', "true");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'no_combat_animations', "false");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'combat_eat_animation', "true");
		theGame.GetInGameConfigWrapper().SetVarValue('miscellaneous_settings', 'allow_loot_animation', "true");
	}	
}